/* Copyright 2011-2012 Profict Holding 
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
package nl.trivento.albero.parsers.groovy.builders.model

import nl.trivento.albero.model.model.CompoundPropertyType
import nl.trivento.albero.utilities.Builder

class PropertyTypeBuilder extends Builder {
	public PropertyTypeBuilder() {
		addBuilder('property', PropertyBuilder)

		setDynamicBuilder('property', 'name')

		defaultProperty = 'type'
	}

	def build(Object... parameters) {
		def propertyType = new CompoundPropertyType(name)

		buildCollection('property', {property ->
			propertyType.addProperty(property)
		}, parameters)

		propertyType
	}
}
